<form autocomplete='off'>
	<nav class='tabs' data-group='books'>
		{{#each books as |book bookId|}}
		<a data-tab='{{bookId}}' data-group='books'>{{localize label}}</a>
		{{/each}}
	</nav>

	<content class='tabs' data-group='books'>
		{{#each books as |book bookId|}}
		<section data-tab='{{bookId}}' data-group='books' class='book {{#unless inUse}}disabled{{/unless}}'>

			{{!-- Basic Config --}}

			<div class='basic config-group'>
				<fieldset>
					<legend>Basic Configuration</legend>

					<div class='form-group'>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.inUse' id='{{@root.uuid}}-{{bookId}}-enabled' type='checkbox' data-dtype='Boolean' {{checked inUse}}>
						<label for='{{@root.uuid}}-{{bookId}}-enabled'>Enabled</label>
					</div>

					<div class='form-group hide-if-disabled'>
						<label for='{{@root.uuid}}-{{bookId}}-name'>Label</label>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.name' id='{{@root.uuid}}-{{bookId}}-name' type='text' data-dtype='String' value='{{name}}' placeholder='{{localize label}}'>
					</div>

					<div class='form-group hide-if-disabled'>
						<label for='{{@root.uuid}}-{{bookId}}-class'>Class</label>
						<select name='system.attributes.spells.spellbooks.{{bookId}}.class' id='{{@root.uuid}}-{{bookId}}-class' data-dtype='String'>
							{{#select class}}
							<option value=''>None</option>
							<option value='_hd'>Hit Dice ({{@root.system.attributes.hd.total}})</option>
							{{#each @root.classes}}
							<option value='{{tag}}'>{{name}} ({{hitDice}})</option>
							{{/each}}
							{{/select}}
						</select>
					</div>

					<div class='form-group hide-if-disabled'>
						<label for='{{@root.uuid}}-{{bookId}}-ability'>Ability</label>
						<select name='system.attributes.spells.spellbooks.{{bookId}}.ability' id='{{@root.uuid}}-{{bookId}}-ability' data-dtype='String'>
							{{#select ability}}
							<option value=''>None</option>
							{{#each @root.config.abilities as |label bookId|}}
							<option value='{{bookId}}'>{{label}} ({{lookup (lookup @root.system.abilities bookId) 'total'}})</option>
							{{/each}}
							{{/select}}
						</select>
					</div>
				</fieldset>


				{{!-- Class Config --}}

				<fieldset class='hide-if-disabled'>
					<legend>Class Configuration</legend>

					<div class='form-group type'>
						<label for='{{@root.uuid}}-{{bookId}}-type'>Casting Type</label>
						<select name='system.attributes.spells.spellbooks.{{bookId}}.spellPreparationMode' id='{{@root.uuid}}-{{bookId}}-type' data-dtype='String'>
							{{selectOptions @root.castingTypes selected=spellPreparationMode localize=true}}
						</select>
					</div>

					<div class='form-group progression'>
						<label for='{{@root.uuid}}-{{bookId}}-progression'>Progression</label>
						<select name='system.attributes.spells.spellbooks.{{bookId}}.casterType'
							id='{{@root.uuid}}-{{bookId}}-progression' data-dtype='String'>
							{{selectOptions @root.castingProgression selected=casterType localize=true}}
						</select>
					</div>

					<div class='form-group cantrips'>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.hasCantrips' id='{{@root.uuid}}-{{bookId}}-cantrips' type='checkbox' data-dtype='Boolean' {{checked hasCantrips}}>
						<label for='{{@root.uuid}}-{{bookId}}-cantrips'>Cantrips</label>
					</div>

					<div class='form-group asf'>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.arcaneSpellFailure' id='{{@root.uuid}}-{{bookId}}-asf' type='checkbox' data-dtype='Boolean' {{checked arcaneSpellFailure}}>
						<label for='{{@root.uuid}}-{{bookId}}-asf'>Arcane Spell Failure <span class='asf box'>(<span class='asf value'>{{@root.actor.spellFailure}}%</span>)</span></label>
					</div>

					<div class='form-group psychic'>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.psychic' id='{{@root.uuid}}-{{bookId}}-psychic' type='checkbox' data-dtype='Boolean' {{checked psychic}}>
						<label for='{{@root.uuid}}-{{bookId}}-psychic'>Psychic</label>
					</div>

					<div class='form-group'>
						<label for='{{@root.uuid}}-{{bookId}}-baseDC'>Base DC Formula</label>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.baseDCFormula' id='{{@root.uuid}}-{{bookId}}-baseDC' type='text' data-dtype='String' value='{{baseDCFormula}}' placeholder='DC base formula'>
					</div>

					<div class='form-group'>
						<label for='{{@root.uuid}}-{{bookId}}-domainSlots'>Domain Slots</label>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.domainSlotValue' id='{{@root.uuid}}-{{bookId}}-domainSlots' type='number' data-dtype='Number' value='{{domainSlotValue}}' min='0' step='1' max='100' placeholder='Domain slots'>
					</div>
				</fieldset>

				{{!-- Misplaced Bonus Formulas --}}

				<fieldset class='hide-if-disabled'>
					<legend>Arbitrary Bonus Formulas</legend>

					<div class='form-group class-level'>
						<label for='{{@root.uuid}}-{{bookId}}-classBonus'>Class Level</label>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.cl.autoSpellLevelCalculationFormula'
							 id='{{@root.uuid}}-{{bookId}}-classBonus' type='text' data-dtype='String' value='{{cl.autoSpellLevelCalculationFormula}}' placeholder='Bonus formula'>
					</div>

					<div class='form-group caster-level'>
						<label for='{{@root.uuid}}-{{bookId}}-clBonus'>Caster Level</label>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.cl.formula'
							id='{{@root.uuid}}-{{bookId}}-clBonus' type='text' data-dtype='String' value='{{cl.formula}}' placeholder='Bonus formula'>
					</div>

					<div class='form-group concentration'>
						<label for='{{@root.uuid}}-{{bookId}}-concBonus'>Concentration</label>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.concentrationFormula'
							id='{{@root.uuid}}-{{bookId}}-concBonus' type='text' data-dtype='String' value='{{concentrationFormula}}' placeholder='Bonus formula'>
					</div>


					<div class='form-group ability-slots'>
						<label for='{{@root.uuid}}-{{bookId}}-slotAblBonus'>Slot Ability Bonus</label>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.spellSlotAbilityBonusFormula'
							id='{{@root.uuid}}-{{bookId}}-slotAblBonus' type='text' data-dtype='String' value='{{spellSlotAbilityBonusFormula}}' placeholder='Bonus formula'>
					</div>
				</fieldset>
			</div>

			{{!-- Second Column --}}

			<div class='slots-and-points config-group hide-if-disabled'>
				{{!-- Spell Points --}}

				<fieldset class='{{#if autoSpellLevelCalculation}}disabled overridden{{else if spellPoints.useSystem}}enabled{{else}}disabled{{/if}}'>
					<legend>Spell Points</legend>

					<div class='form-group use-spellpoints'>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.spellPoints.useSystem' id='{{@root.uuid}}-{{bookId}}-spellpoints' type='checkbox' data-dtype='Boolean' {{checked spellPoints.useSystem}}>
						<label for='{{@root.uuid}}-{{bookId}}-spellpoints'>Enabled {{#if autoSpellLevelCalculation}}<span class='warning'>(Auto-calc slots needs to be disabled)</span>{{/if}}</label>
					</div>

					<div class='form-group spellpoints-max collapse'>
						<label for='{{@root.uuid}}-{{bookId}}-spellpoints-max'>Maximum</label>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.spellPoints.maxFormula' id='{{@root.uuid}}-{{bookId}}-spellpoints-max' type='text' data-dtype='String' value='{{spellPoints.maxFormula}}' placeholder='Spellpoint formula'>
					</div>

					<div class='form-group spellpoints-restored collapse'>
						<label for='{{@root.uuid}}-{{bookId}}-spellpoints-restored'>Restored</label>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.spellPoints.restoreFormula' id='{{@root.uuid}}-{{bookId}}-spellpoints-restored' type='text' data-dtype='String' value='{{spellPoints.restoreFormula}}' placeholder='Restoration formula'>
					</div>
				</fieldset>

				<fieldset>
					<legend>Slot Configuration</legend>

					<div class='form-group auto-slots'>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.autoSpellLevelCalculation'  id='{{@root.uuid}}-{{bookId}}-autoslots' type='checkbox' data-dtype='Boolean' {{checked autoSpellLevelCalculation}}>
						<label for='{{@root.uuid}}-{{bookId}}-autoslots'>Auto calculate spell slots</label>
					</div>

					<div class='form-group auto-slots'>
						<input name='system.attributes.spells.spellbooks.{{bookId}}.autoSpellLevels'  id='{{@root.uuid}}-{{bookId}}-autoslots' type='checkbox' data-dtype='Boolean' {{checked autoSpellLevels}}>
						<label for='{{@root.uuid}}-{{bookId}}-autoabilitybonus'>Automatic ability score bonus slots</label>
					</div>

					<ul style='--spell-columns: {{#if spontaneous}}2{{else}}1{{/if}};' class='form-group spell-slot-grid'>
						{{!--  Header --}}
						<div class='spell-slot-row header'>
							<label>Lv.</label>
							<label>Base</label>
							<label>{{#if spontaneous}}Known{{else}}Prepared{{/if}}</label>
							{{#if spontaneous}}
							<label>/Day</label>
							{{/if}}
							<label>Value</label>
							<label>Max</label>
						</div>

						{{!-- Per level slots --}}
						{{#each spells as |level sl|}}
						{{#if (and (eq ../casterType "med") (gt @index 6))}}
							<!-- Spell level: {{@index}} ({{../bookId}}) --- not available with medium progression -->
						{{else if (and (eq ../casterType "low") (gt @index 4))}}
							<!-- Spell level: {{@index}} ({{../bookId}}) --- not available with low progression -->
						{{else}}
						<li class='spell-slot-row {{#if (and (eq @index 0) (ne ../hasCantrips true))}}disabled{{/if}}' data-level='{{@index}}'>
							<!-- Spell level: {{@index}} ({{../bookId}}) -->
							<label>{{@index}}</label>
							<span>{{base}}</span>
							<input name='system.attributes.spells.spellbooks.{{bookId}}.spells.{{sl}}.preparedOffsetFormula' type='text' data-dtype='String' value='{{preparedOffsetFormula}}' placeholder='Bonus formula'>
							{{#if ../spontaneous}}
							<input name='system.attributes.spells.spellbooks.{{bookId}}.spells.{{sl}}.castPerDayOffsetFormula' type='text' data-dtype='String' value='{{castPerDayOffsetFormula}}' placeholder='Bonus formula'>
							{{/if}}
							<span>{{value}}</span>
							<span>{{max}}</span>
						</li>
						{{/if}}
						{{/each}}
					</ul>
				</fieldset>
			</div>
		</section>
		{{/each}}
	</content>
</form>
